<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-account-group</v-icon
            ><b>Exibindo Equipe</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <v-row class="buttonHoverViewTeam px-3" no-gutters justify="center">
        <v-btn
          v-if="maxUsersByTeam > 1"
          small
          elevation="0"
          text
          :class="searchMode ? 'mr-2' : 'buttonSelected mr-2'"
          @click="showStudents"
        >
          <v-icon small class="mr-2">mdi-account-box-multiple-outline</v-icon>Alunos</v-btn
        >
        <v-btn
          v-if="
            (maxUsersByTeam > 1 && userId == checkIsLeader()) ||
              (maxUsersByTeam > 1 && checkPermissions.get('collaborativeWorkDelete'))
          "
          small
          elevation="0"
          text
          :class="searchMode ? 'buttonSelected' : ''"
          @click="showSearchStudents"
        >
          <v-icon small class="mr-2">mdi-plus</v-icon>Adicionar integrante</v-btn
        >
      </v-row>
      <v-card-text class="scrollForm">
        <!-- Ver turmas -->
        <v-data-table
          v-if="!searchMode"
          calculate-widths
          :headers="headers"
          :items="teamInfo.participants"
          hide-default-footer
          class="px-6 elevation-0"
        >
          <template v-slot:[`item.name`]="{ item }">
            <span>{{ item.user.name }} {{ item.user.surname }}</span>
            <v-icon v-if="item.user.id == checkIsLeader()" color="warning" class="pl-1" small
              >mdi-star</v-icon
            >
          </template>
          <template v-slot:[`item.email`]="{ item }">
            <span>{{ item.user.email }}</span>
          </template>
          <template v-slot:[`item.matriculation`]="{ item }">
            <span>{{ item.user.matriculation }}</span>
          </template>
          <template v-slot:[`item.action`]="{ item }">
            <div class="hoverCollaborative">
              <v-tooltip v-if="!searchMode" nudge-bottom="-5px" bottom color="primary">
                <template v-slot:activator="{ on }">
                  <v-icon v-on="on" @click="sendMessage(item.user)" small class="mr-1"
                    >mdi-email</v-icon
                  >
                </template>
                <span>Enviar mensagem</span>
              </v-tooltip>
              <!-- Deletar para Professor -->
              <v-tooltip
                v-if="checkPermissions.get('collaborativeWorkDelete') && !searchMode"
                nudge-bottom="-5px"
                bottom
                color="primary"
              >
                <template v-slot:activator="{ on }">
                  <v-icon v-on="on" @click="handleDelete(item)" small>mdi-delete</v-icon>
                </template>
                <span>Remover aluno do grupo</span>
              </v-tooltip>
              <!-- Deletar para Lider -->
              <v-tooltip
                v-if="userId == checkIsLeader() && item.user.id != checkIsLeader() && !searchMode"
                nudge-bottom="-5px"
                bottom
                color="primary"
              >
                <template v-slot:activator="{ on }">
                  <v-icon v-on="on" @click="handleDelete(item)" small>mdi-delete</v-icon>
                </template>
                <span>Remover aluno do grupo</span>
              </v-tooltip>
              <!-- Sair do grupo-->
              <v-tooltip
                v-if="maxUsersByTeam > 1 && item.user.id == userId"
                nudge-bottom="-5px"
                bottom
                color="primary"
              >
                <template v-slot:activator="{ on }">
                  <v-icon v-on="on" @click="handleLeaveTeam(item)" small>mdi-account-remove</v-icon>
                </template>
                <span>Sair da equipe</span>
              </v-tooltip>
              <!-- Fim de modos de sair do grupo -->
            </div>
          </template>
        </v-data-table>
        <!-- Tabela procura aluno -->
        <v-row class="mb-4" v-if="searchMode" no-gutters justify="center">
          <v-text-field
            style="max-width: 35%"
            elevation="0"
            v-model="searchText"
            label="Nome, email ou matrícula"
            single-line
            hide-details
          ></v-text-field>
          <v-tooltip color="primary" bottom>
            <template v-slot:activator="{ on }">
              <v-btn
                class="ml-3 mt-4"
                slot="activator"
                color="primary"
                fab
                x-small
                elevation="0"
                v-on="on"
                @click="handleFilter"
              >
                <v-icon small>mdi-magnify</v-icon>
              </v-btn>
            </template>
            <span>Buscar</span>
          </v-tooltip>
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-btn
                class="ml-1 mt-4"
                slot="activator"
                fab
                color="white"
                x-small
                elevation="0"
                v-on="on"
                @click="cleanSearch"
              >
                <v-icon color="red">mdi-magnify-minus-outline</v-icon>
              </v-btn>
            </template>
            <span>Limpar Busca</span>
          </v-tooltip>
        </v-row>
        <v-data-table
          v-if="searchMode"
          calculate-widths
          :search="showSearch"
          :headers="headers"
          :items="usersList"
          :footer-props="{
            itemsPerPageText: 'Usuários por página',
          }"
          class="px-6 elevation-0"
        >
          <template v-slot:[`item.name`]="{ item }">
            <span>{{ item.name }} {{ item.surname }}</span>
          </template>
          <template v-slot:[`item.email`]="{ item }">
            <span>{{ item.email }}</span>
          </template>
          <template v-slot:[`item.matriculation`]="{ item }">
            <span>{{ item.matriculation }}</span>
          </template>
          <template v-slot:[`item.action`]="{ item }">
            <div class="hoverCollaborative">
              <v-tooltip nudge-bottom="-5px" bottom color="primary">
                <template v-slot:activator="{ on }">
                  <v-icon v-on="on" @click="handleAdd(item)" small>mdi-account-plus</v-icon>
                </template>
                <span>Adicionar aluno do grupo</span>
              </v-tooltip>
            </div>
          </template>
        </v-data-table>
      </v-card-text>
      <!-- Botão Fechar -->
    </v-card>
    <!-- Confirma deletar da equipe-->
    <AlertConfirm
      :alert="alert"
      @clickCancelAlert="alert.status = false"
      @clickConfirmAlert="deleteStudent"
    />
    <!-- Confirma sair da equipe-->
    <AlertConfirm
      :alert="alert3"
      @clickCancelAlert="alert3.status = false"
      @clickConfirmAlert="leaveTeam"
    />
    <!-- Confirma adicionar a equipe-->
    <AlertConfirm
      :alert="alert2"
      @clickCancelAlert="alert2.status = false"
      @clickConfirmAlert="addStudent"
    />
  </v-row>
</template>

<script>
import Management from '../../services/management'
import CollaborativeWork from '../../services/collaborativeWork'
export default {
  name: 'ShowTeam',
  props: {
    teamInfo: {
      type: Object,
      default: () => {
        return {}
      },
    },
    availableUsers: {
      type: Array,
      default: () => {
        return []
      },
    },
    idAnswer: { type: String },
    maxUsersByTeam: {
      type: Number,
    },
  },
  computed: {
    checkPermissions() {
      // usar checkPermissions.get('nome da permissão')
      return this.$store.state.user.mappedActions
    },
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
  },
  components: {},
  data: () => ({
    messageRemove: '',
    alert: {
      status: false,
      message: '',
      icon: 'mdi-account-remove',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    userToAdd: '',
    alert2: {
      status: false,
      message: '',
      icon: 'mdi-account-plus',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    alert3: {
      status: false,
      message: '',
      icon: 'mdi-account-remove',
      messageOk: 'Sim',
      messageCancel: 'Não',
    },
    userToDelete: '',
    searchMode: false,
    showSearch: '',
    noResults: false,
    searchText: '',
    filterType: 'name',
    filterTypes: [
      { label: 'Nome', value: 'name' },
      { label: 'Documento', value: 'document' },
      { label: 'Matrícula', value: 'matriculation' },
    ],
    headers: [
      { text: 'Nome', sortable: false, value: 'name', width: '30%' },
      { text: 'Email', sortable: false, value: 'email', width: '35%' },
      { text: 'Matrícula', sortable: false, value: 'matriculation', width: '20%' },
      { text: 'Ações', sortable: false, value: 'action', width: '15%', align: 'center' },
      ,
    ],
    items: [], //items referente a integrantes do grupo
    handleSearch: false, // quando clica para procurar
    itemsFromSearch: [], // buscando alunos para por no grupo
    userId: '',
    usersList: [],
  }),

  async created() {
    const userInfo = await this.$getItem('userInfo')
    this.userId = userInfo.id
    this.removeUsersFromList()
  },
  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.handleClose()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
  },
  methods: {
    async removeUsersFromList() {
      // retirando professor da lista de usuários
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      this.usersList = this.availableUsers.filter((user) => {
        let check = 0
        user.entities.forEach((entity) => {
          if (entity.entity == entityId && entity.privileges.label == 'Professor') check++
        })
        if (check == 0) return user
      })
    },

    handleClose() {
      this.$emit('closeTeamInfo')
      this.resetInfos()
    },
    resetInfos() {
      this.searchMode = false
      this.searchText = ''
      this.filterType = 'name'
      this.handleSearch = false
      this.itemsFromSearch = []
    },
    sendMessage(item) {
      console.log(item, 'enviar msg para usuário')
      this.checkIsLeader()
    },
    handleAdd(item) {
      this.alert2.status = true
      this.alert2.message = `Deseja <b>adicionar</b> ${item.name} ${item.surname} a equipe?`
      this.userToAdd = item
    },
    addStudent() {
      this.updateParticipants(this.idAnswer, this.teamInfo._id, this.userToAdd.id)
      this.alert2.status = false
    },
    handleDelete(item) {
      console.log(this.teamInfo, 'info do time')
      this.alert.status = true
      this.alert.message = `Deseja <b>deletar</b> ${item.user.name} ${item.user.surname} da equipe?`
      this.userToDelete = item
    },

    deleteStudent() {
      let id
      if (this.teamInfo.participants.length > 1) {
        this.teamInfo.participants.forEach((item) => {
          if (item.user.id == this.userToDelete.user.id) id = item._id
        })
        this.messageRemove = 'O integrante do grupo foi <b>removido</b> com sucesso!'
        this.deleteParticipant(this.idAnswer, this.teamInfo._id, id)
        this.$emit('refreshTeamData')
        this.alert.status = false
      } else {
        this.alert.status = false
        this.$store.commit('user/UPDATE_ALERT', {
          status: true,
          message: `Desculpe, <b>não é possível deletar esse usuário</b>, pois o grupo ficara sem nenhum integrante.`,
          icon: 'mdi-close-circle',
          color: 'red',
        })
      }
    },
    handleLeaveTeam(item) {
      this.alert3.status = true
      this.alert3.message = `Deseja <b>sair</b> da equipe?`
      this.userToDelete = item
    },
    leaveTeam() {
      let id
      this.teamInfo.participants.forEach((item) => {
        if (item.user.id == this.userToDelete.user.id) id = item._id
      })
      this.messageRemove = 'Você saiu da equipe!'
      this.deleteParticipant(this.idAnswer, this.teamInfo._id, id)
      this.$emit('refreshTeamData')
      this.alert3.status = false
      this.handleClose()
    },
    showStudents() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.searchMode = false
        this.handleSearch = false
      }, 200)
    },
    showSearchStudents() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.searchMode = true
      }, 200)
    },
    cleanSearch() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 200)
      this.searchText = ''
      this.showSearch = ''
    },

    //lider quem estiver com index = 0
    checkIsLeader() {
      let leader = this.teamInfo.participants[0].user.id
      return leader
    },

    /* 

    integração com backend

    */

    async handleFilter() {
      this.$store.commit('user/UPDATE_LOADING', true)
      setTimeout(() => {
        this.$store.commit('user/UPDATE_LOADING', false)
      }, 200)
      this.showSearch = this.searchText
    },

    async updateParticipants(collaborativeWorkAnswerId, teamId, participantId) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      let actionId
      if (actionsMap.get('collaborativeWorkUpdate'))
        actionId = actionsMap.get('collaborativeWorkUpdate').id
      else actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.updateParticipants(entityId, actionId, {
          collaborativeWorkAnswerId: collaborativeWorkAnswerId,
          teamId: teamId,
          participantId: participantId,
        })
        if (ret.success) {
          this.$emit('refreshTeamData')
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: `Novo integrante <b>adicionado</b> com sucesso!`,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        } else {
          if (
            ret.data.description ==
            "We didn't find an answer to error The team is already at full capacity on model collaborativeWork"
          ) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Desculpe, o grupo já atingiu a <b>quantidade máxima de integrantes</b>, não é possível adicionar mais nenhum usuário.`,
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }

          if (
            ret.data.description ==
            "We didn't find an answer to error User is already a member of another team on model collaborativeWork"
          ) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Desculpe, esse usuário <b>já pertence</b> a outra equipe.`,
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }

          if (
            ret.data.description ==
            "We didn't find an answer to error User is already a member of the team on model collaborativeWork"
          ) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: `Desculpe, esse usuário já está <b>participando do grupo</b>.`,
              icon: 'mdi-close-circle',
              color: 'red',
            })
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.handleSearch = true
      }
    },

    async deleteParticipant(answerId, teamId, participantId) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      let actionId
      if (actionsMap.get('collaborativeWorkUpdate'))
        actionId = actionsMap.get('collaborativeWorkUpdate').id
      else actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await CollaborativeWork.deleteParticipant(entityId, actionId, {
          answerId: answerId,
          teamId: teamId,
          participantId: participantId,
        })
        if (ret.success) {
          this.$emit('refreshTeamData')
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: this.messageRemove,
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.handleSearch = true
      }
    },
  },
}
</script>

<style>
.buttonHoverViewTeam > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.buttonSelected {
  background: #ffc107 !important;
  color: #2a0845 !important;
}
</style>
